Public SleepDelay, OrderStr
On Error Resume Next
Dim HousebotLocation, DOSHousebotLocation 

OrderStr = "title"
DOSHousebotLocation = "C:\Progra~1\Housebot\"
HousebotLocation = "C:\Program Files\housebot\"

Dim ArtistDrillDown
ArtistDrillDown = "Album"		' Double click on Artist in Music Library will cause the Albums to be displayed instead of the songs

Dim NumZones
Dim Zone
NumZones = 4


Set objDB  = CreateObject("newObjects.sqlite3.dbutf8")
objDB.Open(HousebotLocation & "config\scripts\songs.mlf")
objDB.BusyTimeout=1000
objDB.AutoType = True
objDB.TypeInfoLevel = 4
Set su = CreateObject("newObjects.utilctls.StringUtilities")
PopulateGenreList
objDB.Close
Set objDB  = Nothing
Set su  = Nothing

for i=1 to NumZones
	Zonestring = "-"&i
	SetpropertyValue "Jukebox" & ZoneString & ".Jukebox - Import Flag", "Stopped"  
	SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Playlist Modified","No"   'Not modified yet
next

Do
'MsgBox Zonestring & "    " & Action
	for Zone=1 to NumZones
		Sleep 50
		Zonestring = "-"&Zone
   		Action = GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Action")
		If Action <> "Idle" Then
		'MsgBox Zonestring & "    " & Action
			SetpropertyValue "Jukebox" & ZoneString & ".Jukebox - Action", "Idle"
			If Action <> "" Then
				Call Message_Handler(Action)
				If Err.Number <> 0 Then
					Status = "Error: " & Err.Description
					Err.Clear
				End If
			End If
			'Keep this Action = Waiting here so Waiting is set AFTER the command is finished
			'The GetMeedioMessage script waits for Waiting before sending the next input
	'		Action = "Waiting"
			'Update Song Percentatage Once a second
			
		End If
		Sleep 150		'Shouldn't need this anymore, unless you are running just one zone.
	next
Loop

Set objDB = Nothing


Sub Message_Handler(message)
  Set objDB  = CreateObject("newObjects.sqlite3.dbutf8")
  objDB.Open(HousebotLocation & "config\scripts\songs.mlf")
  objDB.BusyTimeout=1000
  objDB.AutoType = True
  objDB.TypeInfoLevel = 4
  Set su = CreateObject("newObjects.utilctls.StringUtilities")
  'msgbox message
  Select Case message
    Case "Song Select"					: 'msgbox "calling populate from song select"
										  call PopulateNameList(1, "True")
	Case "Shuffle Playlist"             : ShufflePlaylist
    Case "Add All Playlist"				: AddAllSongs2PlayList
    Case "Add Song Playlist"			: AddSong2PlayList
    Case "Clear Playlist"				: ClearPlaylist
    Case "Create Playlist"				: CreatePlaylist
    Case "Delete Saved Playlist"		: DeleteSavedPlaylist
    Case "Save Selected Playlist"		: SavedSelectedPlaylist
    Case "Load Selected Playlist"		: LoadSelectedPlaylist
    Case "Play Selected Song"			: PlaySelectedSong
    Case "Play Next Song"				: PlayNextSong
	Case "Play Previous Song"			: PlayPreviousSong
    Case "Import Music Library"			: ImportMusicLibrary
    Case "Song Select No Drilldown"		: 'msgbox "calling populate from song select no drilldown"
										  Call PopulateNameList(1, "False")
    Case "Populate Genre List"			: PopulateGenreList
	Case "Populate Playlist"			: PopulatePlaylist(0)
    Case "Populate Saved Playlist"		: PopulateSavedPlayLists(1)
	Case "LibraryListPageDown"		    : LibraryListPageDown
	Case "LibraryListPageUp"		    : LibraryListPageUp
	Case "SongQueuePageDown"		    : Call SongQueuePageDown(0)
	Case "SongQueuePageUp"			    : Call SongQueuePageUp(0)
	Case "Selected Song Detail"			: ShowLibrarySelectedSong
	Case "Delete Playlist Item"			: DeletePlaylistItem
    Case "Song Percent"					: SongPercent
	Case "Populate Internet Radio"		: PopulateInternetRadio
	Case Else							: 'msgbox "calling populate from default clause"
										  Call PopulateNameList(1, "False")
	
  End Select 
  objDB.Close
  Set objDB = Nothing
  Set su = nothing
End Sub


Sub SongPercent
   Dim SongLengthMin, SongLengthSec, SongLengthTotalSec, SongLengthData
   Dim SongPositionMin, SongPositionSec, SongPositionTotalSec, SongPercent, SongPositionData
   
   'SongLengthData = Array("04","00")
   'SongPositionData = Array("00","00")

   SongLengthData = Split(GetPropertyValue ("Music Player" & ZoneString & ".Song Length"),":")
   ' Was getting Type mismatch below : so I added bounds checking  My guess is that occasionally 
   ' it reads while vaule is being written and it gets a bogus value
   'If TypeName(SongLengthData(0)) <> "String" Or TypeName(SongLengthData(1)) <> "String" Then
'	  Exit Sub
   'End if 
   'If SongLengthData(0) < 0 Or SongLengthData(0) > 60 Or SongLengthData(1) < 0 Or SongLengthData(1) > 60 Then
   '   Exit Sub
   'End If
	
   SongLengthMin = CInt(SongLengthData(0))
   SongLengthSec = CInt(SongLengthData(1))
   SongLengthTotalSec = CInt((SongLengthMin*60)+SongLengthSec)
   SongPositionData = Split(GetPropertyValue ("Music Player" & ZoneString & ".Song Position"),":")

	' Was getting Type mismatch below : so I added bounds checking  My guess is that occasionally 
	' it reads while vaule is being written and it gets a bogus value
    'If TypeName(SongPositionData(0)) <> "String" Or TypeName(SongPositionData(1)) <> "String" Then
	'  Exit Sub
    'End if 
	'If SongPositionData(0) < 0 Or SongPositionData(0) > 60 Or SongPositionData(1) < 0 Or SongPositionData(1) > 60 Then
	'  Exit Sub
	'End If
	SongPositionMin = CInt(SongPositionData(0))
   	SongPositionSec = CInt(SongPositionData(1))
	SongPositionTotalSec = CInt((SongPositionMin*60)+SongPositionSec)
	SongPercent = CInt(Round((SongPositionTotalSec/SongLengthTotalSec)*100))
	SetPropertyValue "Music Player - Misc.Song Percent", SongPercent
End Sub

Sub LibraryListPageDown
PageCount = GetPropertyValue("Jukebox" & ZoneString & ".Jukebox Library List Page Count")
PageTotal = GetPropertyValue("Jukebox" & ZoneString & ".Jukebox Library List Page Total")

'MsgBox "Page Down" & PageCount & ", " & PageTotal
   If CInt(PageCount) < CInt(PageTotal) Then
    PageCount = CInt(PageCount) + 1
	SetPropertyValue "Jukebox" & ZoneString & ".Jukebox Library List Page Count", PageCount
	Call PopulateNameList (CInt(PageCount), "False")	  
   End If
'sleep 150
End Sub

Sub LibraryListPageUp
PageCount = GetPropertyValue("Jukebox" & ZoneString & ".Jukebox Library List Page Count")
PageTotal = GetPropertyValue("Jukebox" & ZoneString & ".Jukebox Library List Page Total")
 'MsgBox "Page Up" & PageCount & ", " & PageTotal
   If CInt(PageCount) > 1 Then
      PageCount = CInt(PageCount) - 1
	  SetPropertyValue "Jukebox" & ZoneString & ".Jukebox Library List Page Count", PageCount 
	  Call PopulateNameList (CInt(PageCount), "False")
   End If
   'sleep 150
End Sub
    
Sub SongQueuePageDown(retainpage)
PageCount = CInt(GetPropertyValue("Jukebox" & ZoneString & ".Jukebox Song Queue List Page Count"))
PageTotal = CInt(GetPropertyValue("Jukebox" & ZoneString & ".Jukebox Song Queue List Page Total"))
   If PageCount < PageTotal Then
    PageCount = PageCount + 1
	SetPropertyValue "Jukebox" & ZoneString & ".Jukebox Song Queue List Page Count", PageCount 
	sleep 50
	Call PopulatePlayList (GetPropertyValue("Jukebox" & ZoneString & ".Now Playing - Queue Number"))
   End If

'sleep 150
End Sub

Sub SongQueuePageUp(retainpage)
PageCount = CInt(GetPropertyValue("Jukebox" & ZoneString & ".Jukebox Song Queue List Page Count"))
PageTotal = CInt(GetPropertyValue("Jukebox" & ZoneString & ".Jukebox Song Queue List Page Total"))
'sleep 50
 'MsgBox PageCount & ", " & PageTotal
   If PageCount > 1 Then
    PageCount = PageCount - 1
	SetPropertyValue "Jukebox" & ZoneString & ".Jukebox Song Queue List Page Count", PageCount 
	sleep 50
	Call PopulatePlayList(GetPropertyValue("Jukebox" & ZoneString & ".Now Playing - Queue Number"))
   End If

End Sub

Sub NowPlayingThumbnail
	rem- this is markd's method, which works with folder.jpg images in the album directory.  Faster as there is no extraction call
	rem  Structure of SelectedSong m:/mymusic/Kill Hannah/For Never and Ever/03 - 10 More Minutes.mp3
	Dim Parse1, CurrentSong, ImageFile, objFSO
	Parse1 = 0
	CurrentSong = GetPropertyValue("Music Player" & ZoneString & ".Play Source")
	rem prune off the song name and replace with folder.jpg
  
	Parse1 = InStr(CurrentSong, "mymusic/")
	Parse1 = InStr(Parse1 + 8, CurrentSong, "/")
	Parse1 = InStr(Parse1 + 1, CurrentSong, "/")
	
	rem Have to reverse the slashes. . .  
	ImageFile = Replace(Left(CurrentSong,Parse1) & "folder.jpg","/","\")
	
	Set objFSO = CreateObject("Scripting.FileSystemObject")
	If objFSO.FileExists (ImageFile) then
		SetPropertyValue "Jukebox" & ZoneString & ".Now Playing Image", Imagefile
	Else
	rem Original method that extracts images out of mp3s- if the folder.jpg is not available. Slight mod to always write into SelectedSong.jpg
	   Dim CmdStr, JavaStr, oShell 
	  
	   ImageFile = HousebotLocation & "config\themes\THC Jukebox\" & ZoneString & "SelectedSong.jpg"
	   
	   ' Copy Default image so if embedded image not found displays default image.
	   Set objFSO = CreateObject("Scripting.FileSystemObject")
	   objFSO.CopyFile HousebotLocation & "config\themes\THC Jukebox\nocoverart.jpg"_
	   , HousebotLocation & "config\themes\THC Jukebox\folder.jpg", True
	   CmdStr = "java -cp " & DOSHousebotLocation & "Config\Scripts;" & DOSHousebotLocation _ 
	   & "Config\Scripts\Bin;MP3Tag-0.3.jar com.revasoft.jmp3tagextractor.Mp3ImageTagExtractor -srcFile """ _
	   & CurrentSong & """ -targetfileextension jpg -targetfile """ & ImageFile & """ -overwriteExisting"
	  
	   Set oShell = CreateObject( "WScript.Shell" )
	   oShell.Run CmdStr, 0, True
	   SetPropertyValue "Jukebox" & ZoneString & ".Now Playing Image", ImageFile
	   Sleep 5
	   SetPropertyValue "Jukebox" & ZoneString & ".Now Playing Image", ImageFile
	   Sleep 5
	   ' Close & Free Objects
	   Set oShell = Nothing
	end if
	
	Set objFSO = Nothing
  
End Sub

Sub SelectedSongThumbnail
   
	rem- this is markd's method, which works with folder.jpg images in the album directory.
	rem  Structure of SelectedSong m:/mymusic/Kill Hannah/For Never and Ever/03 - 10 More Minutes.mp3
	Dim Parse1, SelectedSong, ImageFile, objFSO
	Parse1 = 0
  
	SelectedSong = GetPropertyValue("Jukebox" & ZoneString & ".Jukebox - File")
	rem prune off the song name and replace with folder.jpg
  
	Parse1 = InStr(SelectedSong, "mymusic/")
	Parse1 = InStr(Parse1 + 8, SelectedSong, "/")
	Parse1 = InStr(Parse1 + 1, SelectedSong, "/")
	
	rem Have to reverse the slashes. . . 
  
	ImageFile = Replace(Left(SelectedSong,Parse1) & "folder.jpg","/","\")
	
	Set objFSO = CreateObject("Scripting.FileSystemObject")
	If objFSO.FileExists (ImageFile) then
		SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Selected Song Image", Imagefile
	Else
		rem- This is the original method, which works with embedded cover art. Slight mod to always write into SelectedSong.jpg
		Dim CmdStr, JavaStr, CurrentSong 
		  
		CurrentSong = GetPropertyValue("Jukebox" & ZoneString & ".Jukebox - File")
		ImageFile = HousebotLocation & "config\themes\THC Jukebox\" & ZoneString & "SelectedSong.jpg"
		   
		' Copy Default image so if embedded image not found displays default image.
		Set objFSO = CreateObject("Scripting.FileSystemObject")
		objFSO.CopyFile HousebotLocation & "config\themes\THC Jukebox\nocoverart.jpg"_
		, HousebotLocation & "config\themes\THC Jukebox\SelectedSong.jpg", True
		   
		CmdStr = "java -cp " & DOSHousebotLocation & "Config\Scripts;" & DOSHousebotLocation _ 
		& "Config\Scripts\Bin;MP3Tag-0.3.jar com.revasoft.jmp3tagextractor.Mp3ImageTagExtractor -srcFile """ _
		& CurrentSong & """ -targetfileextension jpg -targetfile """ & ImageFile & """ -overwriteExisting"
		Dim oShell 
		Set oShell = CreateObject( "WScript.Shell" )
		oShell.Run CmdStr, 0, True
		'sleep 300
		SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Selected Song Image", ImageFile
		sleep 5
		SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Selected Song Image", ImageFile
		sleep 5
		' Close & Free Objects
		Set oShell = Nothing
	end if
	
	Set objFSO = Nothing
End Sub



Sub PlayNextSong
   'msgbox "In PlayNextSong"
   If Trim(GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Playing Song")) <> "" Then
      queuenmbr = GetPropertyValue("Jukebox" & ZoneString & ".Now Playing - Queue Number") 
	  'CInt(Right(GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Playing Song"),Len(GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Playing Song")) - 9))
      'MsgBox (((queuenmbr + 1)\100)+1) & ", " & GetPropertyValue("Jukebox" & ZoneString & ".Jukebox Song Queue List Page Count") 
  
	  SqlStr = "select * from songqueue where playlistid = " & Zone
      Set r = objDB.Execute(SqlStr)
      SetPropertyValue "Jukebox" & ZoneString & ".Now Playing - Queue Total", r.Count
      'MsgBox r.Count & ", " & Cint(queuenmbr)    
	  If r.Count > Cint(queuenmbr) Then
	     SetPropertyValue "Jukebox" & ZoneString & ".Now Playing - Queue Number", queuenmbr + 1
         If (((queuenmbr)\100)+1)  <>  CInt(GetPropertyValue("Jukebox" & ZoneString & ".Jukebox Song Queue List Page Count")) Then
		    
            SongQueuePageDown(1)
		 Else
            'MsgBox "Calling populate q+1 where q = " & queuenmbr
			Call PopulatePlayList(queuenmbr + 1)
	     End If
   		 sleep 50
         SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Playing Song", "Playlist^" & queuenmbr + 1 & "^" & PlayListSongID(queuenmbr + 1)
   		 sleep 1000
		 PlaySelectedSong
	  Else
         If GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Repeat") = "On" Then
            SetPropertyValue "Jukebox" & ZoneString & ".Now Playing - Queue Number", 1
			If (((queuenmbr)\100)+1)  <>  CInt(GetPropertyValue("Jukebox" & ZoneString & ".Jukebox Song Queue List Page Count")) Then
	           'MsgBox "Got Here"
               SongQueuePageDown(1)
		    Else
			   SetPropertyValue "Jukebox" & ZoneString & ".Jukebox Song Queue List Page Count", 1
               'MsgBox "Calling populate 1"
			   Call PopulatePlayList(1)
			End If
        
			sleep 50
			SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Playing Song", "Playlist^1" & "^" & PlayListSongID(1)
            'SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Playing Song", "Playlist^" & queuenmbr + 1 & "^" & PlayListSongID(queuenmbr + 1)
            sleep 150
			PlaySelectedSong
		 End If
      End If
      Set r = Nothing
   End If
   'sleep 300
   'NowPlayingThumbnail
   'MsgBox "Leaving Play next song"
End Sub

Sub PlayPreviousSong
   If Trim(GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Playing Song")) <> "" Then
  	  queuenmbr = GetPropertyValue("Jukebox" & ZoneString & ".Now Playing - Queue Number")

	  'account for page logic
	  
	  ' Right(GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Playing Song"),Len(GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Playing Song")) - 9)
      SqlStr = "select * from songqueue where playlistid = " & Zone
      Set r = objDB.Execute(SqlStr)
      SetPropertyValue "Jukebox" & ZoneString & ".Now Playing - Queue Total", r.Count
      If Cint(queuenmbr) > 1  Then
         SetPropertyValue "Jukebox" & ZoneString & ".Now Playing - Queue Number", queuenmbr - 1
		 
		 'MsgBox (((queuenmbr - 2)\100)+1) & ", " & GetPropertyValue("Jukebox" & ZoneString & ".Jukebox Song Queue List Page Count") 
         If (((queuenmbr - 2)\100)+1)  <>  CInt(GetPropertyValue("Jukebox" & ZoneString & ".Jukebox Song Queue List Page Count")) Then
            SongQueuePageUp(1)
		 Else
		    'MsgBox "Got Milk"
            Call PopulatePlayList(queuenmbr - 1)
	     End if
		 sleep 50		 
         SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Playing Song", "Playlist^" & queuenmbr - 1 & "^" & PlayListSongID(queuenmbr - 1)
		 sleep 150
		 PlaySelectedSong
      End If
      Set r = Nothing
   End If
   'sleep 300
   'NowPlayingThumbnail
End Sub

Sub PlaySelectedSong
  Dim data, SqlStr
  If Trim(GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Playing Song")) <> "" Then
     data = Split(GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Playing Song"),"^")
	 'msgbox data(1)
	 SetPropertyValue "Jukebox" & ZoneString & ".Now Playing - Queue Number", data(1)
	 'SqlStr = "select * from songs where id = (select songid from songqueue where id = " & data(1) & ")"
	 SqlStr = "select * from songs where id = " & data(2)
     'MsgBox SqlStr
     Set r = objDB.Execute(SqlStr)
     SetPropertyValue "Music Player" & ZoneString & ".Play Source", r(1)("file")
	 'MsgBox "Music Player" & Zonestring & " " & r(1)("file")
	 SetPropertyValue "Jukebox" & ZoneString & ".Now Playing - Genre", r(1)("genre")
	 SetPropertyValue "Jukebox" & ZoneString & ".Now Playing - Album", r(1)("album")
	 SetPropertyValue "Jukebox" & ZoneString & ".Now Playing - Artist", r(1)("artist")
	 SetPropertyValue "Jukebox" & ZoneString & ".Now Playing - Title", r(1)("title")
	 SetPropertyValue "Jukebox" & ZoneString & ".Now Playing - Track", r(1)("track")
	 SetPropertyValue "Jukebox" & ZoneString & ".Now Playing - Year", r(1)("year")
     ' If songs plays twice add more sleep time
	 sleep 8000
	 SetPropertyValue "Music Player" & ZoneString & ".Status", "Playing"
	 Set r = Nothing
  End If
  sleep 60
  NowPlayingThumbnail
  'sleep 500
End Sub

Sub ShowLibrarySelectedSong

     If GetPropertyValue ("Jukebox" & ZoneString & ".Tag Type") = "title" Then
		 SqlStr = "select * from songs where id = " _ 
		 & Mid(GetPropertyValue ("Jukebox" & ZoneString & ".Selected Name"),11)
		 'MsgBox SqlStr
		 Set r = objDB.Execute(SqlStr)
		 sleep 50
		 SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Genre", r(1)("genre")
		 SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Album", r(1)("album")
		 SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Artist", r(1)("artist")
		 SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Title", r(1)("title")
		 SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Track", r(1)("track")
		 SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Year", r(1)("year")
		 SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - File", r(1)("file")
         Set r = Nothing		 
		 sleep 75
		 SelectedSongThumbnail
	elseif GetPropertyValue ("Jukebox" & ZoneString & ".Tag Type") = "album" then
		SqlStr = "select * from songs where album = """ _ 
		& Mid(GetPropertyValue ("Jukebox" & ZoneString & ".Selected Name"),11) & _
		""" AND artist =""" & GetPropertyValue("Jukebox" & ZoneString & ".Jukebox - Artist") & """"
		
		'MsgBox SqlStr
		Set r = objDB.Execute(SqlStr) 
		If r.Count <> 0 Then
		'MsgBox "Count <> 0"
		SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Genre", r(1)("genre") 
		SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Album", r(1)("album") 
		SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Artist", r(1)("artist") 
		SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Title", "" 
		SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Track", "" 
		SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Year", r(1)("year") 
		SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - File", r(1)("file") 
		'MsgBox SqlStr
		end if
		Set r = Nothing 
		sleep 75 
		SelectedSongThumbnail
	elseif GetPropertyValue ("Jukebox" & ZoneString & ".Tag Type") = "artist" then
		SqlStr = su.Sprintf("select * from songs where artist = %Nq" _ 
		, Right(GetPropertyValue ("Jukebox" & ZoneString & ".Selected Name"),Len(GetPropertyValue ("Jukebox" & ZoneString & ".Selected Name")) - 10)) 
		'MsgBox SqlStr
		Set r = objDB.Execute(SqlStr) 
		If r.Count <> 0 Then
		SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Genre", r(1)("genre") 
		SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Album", r(1)("album") 
		SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Artist", r(1)("artist") 
		SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Title", "" 
		SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Track", "" 
		SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Year", r(1)("year") 
		SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - File", r(1)("file") 
		'MsgBox SqlStr
		end if
		Set r = Nothing 
		sleep 75 
		SelectedSongThumbnail
	End if

End Sub

Function ProcessSongSelect(PageNmbr)
  If GetPropertyValue ("Jukebox" & ZoneString & ".Tag Type") = "album" Then
    'MsgBox "Album"
  ElseIf GetPropertyValue ("Jukebox" & ZoneString & ".Tag Type") = "artist" Then
    'MsgBox "Artist"
  End if
End Function


Function GetPropertyValueTrapErrors(PropertyName, ErrorProperty)
On Error Resume Next
Dim Status, i, RetryCount
RetryCount = 5
   For i=1 To RetryCount
      Status = ""
	  TmpPropertyValue = GetPropertyValue(PropertyName)
	  If Err.Number <> 0 Then
         Status = PropertyName & " Read Error: " & Err.Description
	     Err.Clear
		 If i = 5 Then
            SetPropertyValue ErrorProperty, Status
            'Return Error
			TmpPropertyValue = "Error"
		 End if
	  Else
	     ' Good Read
         Exit For
      End If
   Next
   'Return 
   GetPropertyValueTrapErrors = TmpPropertyValue
End Function


'PopulateGenreList
Sub SavedSelectedPlaylist
  Dim SelectedPlaylist, SqlStr, r
  ' delete existing songs from selected savedplaylist 
  SelectedPlaylist = GetPropertyValueTrapErrors ("Jukebox" & ZoneString & ".Jukebox - Selected Playlist", "Jukebox" & ZoneString & ".Error")
  If SelectedPlaylist <> "Error" Then 
     objDB.Execute("delete from savedplaylists where playlistid  = " & Right(SelectedPlaylist,Len(SelectedPlaylist) - 14))
  End If

  Set r = objDB.Execute("select * from songqueue where playlistid = " & Zone)
  For Row = 1 To r.Count
	 SelectedPlaylist = GetPropertyValueTrapErrors ("Jukebox" & ZoneString & ".Jukebox - Selected Playlist", "Jukebox" & ZoneString & ".Error")
	 If SelectedPlaylist <> "Error" Then 
        objDB.Execute su.Sprintf("INSERT INTO savedplaylists (playlistid, songid) VALUES (%Nq, %Nq)"_
		, Right(SelectedPlaylist,Len(SelectedPlaylist) - 14), r(Row)("songid") )
	 End if
  Next
  Set r = Nothing
  Sleep 500
  PopulateSavedPlayLists(1)
End Sub

Sub LoadSelectedPlaylist
  ' delete existing songs from selected savedplaylist 
  SqlStr = "delete from songqueue where playlistid = " & Zone
  objDB.Execute(SqlStr)

  SqlStr = "select * from savedplaylists where playlistid  = " & Right(GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Selected Playlist")_
  ,Len(GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Selected Playlist")) - 14)
  Set r = objDB.Execute(SqlStr)
  For Row = 1 To r.Count 
     objDB.Execute su.Sprintf("INSERT INTO songqueue (playlistid, songid) VALUES (%Nq, %Nq)", Zone, r(Row)("songid") )
  Next
  ' fetch the playlist name for the loaded playlist
  SqlStr = "select playlistnames.playlistname from playlistnames where playlistnames.id ="_
  & Right(GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Selected Playlist"),Len(GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Selected Playlist")) - 14)
  'msgbox SqlStr
  Set r = objDB.Execute(SqlStr)
  'msgbox r(1)("playlistname")
  SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Current Playlist Name", r(1)("playlistname")
  Set r = Nothing
  SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Playlist Modified","No" 
  sleep 500
  Call PopulatePlayList(0)
End Sub


Sub DeleteSavedPlaylist
  SqlStr = "delete from playlistnames where id = " & Right(GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Selected Playlist")_
  ,Len(GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Selected Playlist")) - 14)
  objDB.Execute(SqlStr)
  SqlStr = "delete from savedplaylists where playlistid  = " & Right(GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Selected Playlist")_
  ,Len(GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Selected Playlist")) - 14)
  objDB.Execute(SqlStr)
 'MusicList = Row & vbCR
  Sleep 500
  PopulateSavedPlayLists(1)
End Sub


Sub CreatePlaylist
   SqlStr = su.Sprintf("select * from playlistnames where playlistname = %Nq", GetPropertyValue ("Keyboard" & ZoneString & ".Keyboard Buffer"))
   'msgbox SqlStr
   Set r = objDB.Execute(SqlStr)

   If (r.count = 0) Then
      objDB.Execute su.Sprintf("INSERT INTO playlistnames (playlistname) VALUES (%Nq)", GetPropertyValue ("Keyboard" & ZoneString & ".Keyboard Buffer"))
   Else
       objDB.Execute su.Sprintf("INSERT INTO playlistnames (playlistname) VALUES (%Nq)", GetPropertyValue ("Keyboard" & ZoneString & ".Keyboard Buffer") & "1")
   End If

   Set r = Nothing

   ' Clear Kbd Buffer
   SetPropertyValue "Keyboard" & ZoneString & ".Keyboard Buffer", ""
   SetPropertyValue "Keyboard" & ZoneString & ".Keyboard Cursor", "^"
   sleep 500
   PopulateSavedPlayLists(1)
End Sub

Sub PopulateInternetRadio
	PlayList = ""

	SqlStr = "select * from internetstream"

	Set r = objDB.Execute(SqlStr)
	'msgbox SqlStr
	
	' Check Subscript Range
	If (PageNmbr >  TotalPages) Then
	   PageNmbr = TotalPages
	End If

	   StartCount = 1
	   EndCount = r.Count

	If r.Count = 0 Then
	   PlayList     = " " & vbTAB & "No Streaming Stations Saved" & vbLF
	End if 

	'  SqlStr = "select * from savedplaylists where playlistid = " & r(Row)("id")
	  
	For Row = StartCount To EndCount

	  PlayList = PlayList & r(Row)("path") & vbTAB & r(Row)("title") & vbLF
	Next

	Set r = Nothing
	SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Streams", Left(PlayList,Len(PlayList)-1)

End Sub

'not in use
Sub PlaySelectedStream
  Dim data, SqlStr
  If Trim(GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Streams")) <> "" Then
     data = Split(GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Playing Song"),"^")
	 SetPropertyValue "Jukebox" & ZoneString & ".Now Playing - Queue Number", data(1)
	 'SqlStr = "select * from songs where id = (select songid from songqueue where id = " & data(1) & ")"
	 SqlStr = "select * from songs where id = " & data(2)
     'MsgBox SqlStr
     Set r = objDB.Execute(SqlStr)
     SetPropertyValue "Music Player" & ZoneString & ".Play Source", r(1)("file")
	 'MsgBox "Music Player" & Zonestring & " " & r(1)("file")
	 SetPropertyValue "Jukebox" & ZoneString & ".Now Playing - Genre", r(1)("genre")
	 SetPropertyValue "Jukebox" & ZoneString & ".Now Playing - Album", r(1)("album")
	 SetPropertyValue "Jukebox" & ZoneString & ".Now Playing - Artist", r(1)("artist")
	 SetPropertyValue "Jukebox" & ZoneString & ".Now Playing - Title", r(1)("title")
	 SetPropertyValue "Jukebox" & ZoneString & ".Now Playing - Track", r(1)("track")
	 SetPropertyValue "Jukebox" & ZoneString & ".Now Playing - Year", r(1)("year")
     ' If songs plays twice add more sleep time
	 sleep 8000
	 SetPropertyValue "Music Player" & ZoneString & ".Status", "Playing"
	 Set r = Nothing
  End If
  sleep 60
  NowPlayingThumbnail
  'sleep 500
End Sub




Sub PopulateSavedPlayLists(pagenmbr)
Dim PlayList, SqlStr, r

PlayList = ""

PageNmbr = 1

SqlStr = "select * from playlistnames"

Set r = objDB.Execute(SqlStr)

TotalPages = (r.Count\100) + 1


' Check Subscript Range
If (PageNmbr >  TotalPages) Then
   PageNmbr = TotalPages
End If

LastPage =  r.Count Mod 100

If PageNmbr = 1 Then
   StartCount = 1
Else 
    StartCount = ((PageNmbr-1)*100) + 1
End If

If (PageNmbr >=  TotalPages-1) Then
   EndCount = ((TotalPages-1)*100) + LastPage
Else
   EndCount = PageNmbr * 100 
End If

If r.Count = 0 Then
   PlayList     = " " & vbTAB & "No Playlists Saved" & vbLF
End if 

For Row = StartCount To EndCount
  SqlStr = "select * from savedplaylists where playlistid = " & r(Row)("id")
  Set s = objDB.Execute(SqlStr)

  PlayList = PlayList & "SavedPlaylist^" & r(Row)("id") & vbTAB & r(Row)("playlistname") & vbTAB & " (" & s.Count & ")" & vbLF
 'MusicList = Row & vbCR
Next

Set r = Nothing
SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Saved Playlists", Left(PlayList,Len(PlayList)-1)

End Sub


Sub PopulateNameList(pagenmbr,drilldown)
Dim MusicList, tagType, SortLetter, usewhere, r, TotalPages, WhereStr
   
   'Dim filesys, testfile 
   'Set filesys = CreateObject("Scripting.FileSystemObject") 
   'Set testfile= filesys.CreateTextFile("c:\MusicList.txt", True) 
   
   'msgbox "In Populate  " & drilldown
   tagType = GetPropertyValue ("Jukebox" & ZoneString & ".Tag Type")
   usewhere = 0
   GenreStr = ""
   SearchLetterStr = ""
   MusicList = ""
   
   If drilldown = "True"  Then
     If tagType= "album" Then
	 'MsgBox "Almost there. .  ."
        SqlStr = "select * from songs where album = """ & Mid(GetPropertyValue ("Jukebox" & ZoneString & ".Selected Name"), 11) & _
		""" AND artist = """ & GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Artist") & _
		""" order by CAST(track AS INTEGER)"
		'MsgBox SqlStr
		SetModeState "Allow Run Jukebox Script", "Inactive"
		sleep 50
		SetPropertyValue "Jukebox" & ZoneString & ".Tag Type", "title"
        SetModeState "Allow Run Jukebox Script", "Active"
		OrderStr = "album"
		tagType = "title"
		'MsgBox GetPropertyValue ("Jukebox" & ZoneString & ".Selected Name")
     ElseIf tagType= "artist" Then
	    'MsgBox GetPropertyValue ("Jukebox" & ZoneString & ".Selected Name")
		if ArtistDrillDown = "Album" then
			SqlStr = "select distinct album from songs where artist = '" & _
			Mid(GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Double-Click Name"),11) & "' order by year collate nocase"
        else
			SqlStr = "select * from songs where artist = '" & Replace(Mid(GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Double-Click Name")_
			,11,Len(GetPropertyValue ("Jukebox" & ZoneString & ".Selected Name")) -10), "'","''") & "' order by title collate nocase"
		end if
		'MsgBox "2"
		SetModeState "Allow Run Jukebox Script", "Inactive"
		sleep 50
		
		if ArtistDrillDown = "Album" then
			SetPropertyValue "Jukebox" & ZoneString & ".Tag Type", "album"
        else
			SetPropertyValue "Jukebox" & ZoneString & ".Tag Type", "title"
		end if
		sleep 50
		SetModeState "Allow Run Jukebox Script", "Active"
				
		SetPropertyValue "Jukebox" & ZoneString & ".Selected Name", ""
		
 		if ArtistDrillDown = "Album" then
			OrderStr = "year"
			tagType = "album"
        else
			OrderStr = "artist"
			tagType = "title"
		end if
		
	 Else
	    AddSong2PlayList
	    Exit Sub
   	 End If
   Else
      If GetPropertyValue ("Jukebox" & ZoneString & ".Selected Genre") <> "All" Then
         usewhere = usewhere + 1
         If usewhere > 1 Then
            GenreStr = " AND "
         End if
         GenreStr = GenreStr & "genre = '" & GetPropertyValue ("Jukebox" & ZoneString & ".Selected Genre") & "'"
		 sleep 150
		 PopulateGenreList
      End If
   
      If GetPropertyValue ("Jukebox" & ZoneString & ".Search Letter") <> "All" Then
         usewhere = usewhere + 1
         If usewhere > 1 Then
            SearchLetterStr = " AND "
         End if
         SearchLetterStr = SearchLetterStr & tagType & " like '" & GetPropertyValue ("Jukebox" & ZoneString & ".Search Letter") & "%'"
      End if
   
      If usewhere >= 1 Then
         WhereStr = " where "
      Else 
         WhereStr = ""
      End If
   
      If tagType = "title" Then
		SqlStr = "select * from songs" & WhereStr & GenreStr & SearchLetterStr & " order by title" 
		' & OrderStr & " collate nocase"
		'MsgBox "3: " & SqlStr
      Else
        SqlStr = "select distinct " & tagType & " from songs" & WhereStr & GenreStr & SearchLetterStr _
		& " order by " & tagType & " collate nocase"
        'MsgBox "4: " & SqlStr	
      End If
   End if
   'SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Last Last SQL", GetPropertyValue("Jukebox" & ZoneString & ".Jukebox - Last SQL")
   SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Last SQL", SqlStr
   'MsgBox SqlStr
   Set r = objDB.Execute(SqlStr)
   
   ' Page Logic 
   TotalPages = ((r.Count-1)\100)+1
   SetPropertyValue "Jukebox" & ZoneString & ".Jukebox Library List Page Total", TotalPages
   ' Check Subscript Range
   If PageNmbr  >  TotalPages Then
      PageNmbr = TotalPages
   End If
   SetPropertyValue "Jukebox" & ZoneString & ".Jukebox Library List Page Count", PageNmbr
   LastPage =  r.Count Mod 100
   If LastPage = 0  Then
      LastPage = 100
   End if
   If PageNmbr <= 1 Then
         StartCount = 1
   Else 
      MusicList = ""
      StartCount = ((PageNmbr-1)*100) + 1
   End If

   If (PageNmbr >=  TotalPages) Then
      EndCount = ((TotalPages-1)*100) + LastPage
   Else
      EndCount = PageNmbr * 100 
   End If
   ' End Of Page Logic

   'MsgBox StartCount & ", " & EndCount & "," & r.Count

   If r.Count = 0 Then
      MusicList     = vbTAB & "No Records Found" & vbLF
   Else 
      For Row = StartCount To EndCount
         If tagType = "title" Then
            MusicList = MusicList & "MusicList^" & r(Row)("id") & vbTAB & r(Row)(tagType) & vbLF
         Else
			if Row = StartCount Then
					MusicList = MusicList & "*S-MusicList^" & r(Row)(tagType) & vbTAB & r(Row)(tagType) & vbLF
				else
					MusicList = MusicList & "MusicList^" & r(Row)(tagType) & vbTAB & r(Row)(tagType) & vbLF
			end if
         End if
      Next
   End if

  Set r = Nothing
  'MsgBox Len(MusicList)-1
  SetPropertyValue "Jukebox" & ZoneString & ".Name List", Left(MusicList,Len(MusicList)-1) 
  sleep 250
  ShowLibrarySelectedSong
  'MsgBox "leaving Populate Name List."
End Sub

' Delete a playlist
Sub DeletePlaylistItem
   Dim data
   data = Split(GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Playing Song"),"^")
   SqlStr = "delete from songqueue where songid = " & data(2) & " and playlistid = " & Zone
   objDB.Execute(SqlStr)
   SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Playlist Modified","Yes"
   sleep 250
   Call PopulatePlayList(0)
End Sub

Sub AddSong2PlayList
	 objDB.Execute su.Sprintf("INSERT INTO songqueue (playlistid, songid) VALUES (%Nq,%Nq)",Zone,_
	 Right(GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Double-Click Name"),Len(GetPropertyValue ("Jukebox" & ZoneString & ".Jukebox - Double-Click Name")) - 10))
	 sleep 50
	 SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Playlist Modified","Yes"
    Call PopulatePlayList(0)
End Sub


Sub AddAllSongs2PlayList
   If GetPropertyValue("Jukebox" & ZoneString & ".Tag Type") = "title" Then
		'SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Last Last SQL", GetPropertyValue("Jukebox" & ZoneString & ".Jukebox - Last SQL")
		SqlStr = GetPropertyValue("Jukebox" & ZoneString & ".Jukebox - Last SQL")
		Set r = objDB.Execute(SqlStr)
		For Row = 1 To r.Count
			objDB.Execute su.Sprintf("INSERT INTO songqueue (playlistid, songid) VALUES (%Nq,%Nq)",Zone,r(Row)("id"))
		Next
		Set r = Nothing
	else 
		If GetPropertyValue("Jukebox" & ZoneString & ".Tag Type") = "album" Then
			SqlStr = Replace(GetPropertyValue("Jukebox" & ZoneString & ".Jukebox - Last SQL"), "select distinct album from songs", "select * from songs")
			'msgbox SqlStr
			Set r = objDB.Execute(SqlStr)
			For Row = 1 To r.Count
				objDB.Execute su.Sprintf("INSERT INTO songqueue (playlistid, songid) VALUES (%Nq,%Nq)",Zone,r(Row)("id"))
			Next
			Set r = Nothing
		end if
	end if
	SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Playlist Modified","Yes"
	SetPropertyValue "Jukebox" & ZoneString & ".Jukebox Library List Page Count", 1
	sleep 150
    Call PopulatePlayList(0)
End Sub



Function PopulateGenreList
Dim GenreList


PageNmbr = 1

SqlStr = "select * from genre order by genre"


Set r = objDB.Execute(SqlStr)

'MsgBox SqlStr

TotalPages = (r.Count\100) + 1


' Check Subscript Range
If (PageNmbr >  TotalPages) Then
   PageNmbr = TotalPages
End If

LastPage =  r.Count Mod 100

If PageNmbr = 1 Then
	StartCount = 2
	if (GetPropertyValue ("Jukebox" & ZoneString & ".Selected Genre") = "All") Then
		GenreList     = "*S-" & "All" & vbTAB & "All"
	else
		GenreList     = "All" & vbTAB & "All"
	end if
Else 
   GenreList = ""
   StartCount = ((PageNmbr-1)*100) + 1
End If

If r.Count = 0 Then
   GenreList     = "*S-" & "All" & vbTAB & "No Records Found"
End if 

If (PageNmbr >=  TotalPages-1) Then
   EndCount = ((TotalPages-1)*100) + LastPage
Else
   EndCount = PageNmbr * 100 
End If
For Row = StartCount To EndCount
  If (GetPropertyValue ("Jukebox" & ZoneString & ".Selected Genre") = r(Row)("genre")) Then
  'msgbox r(Row)("genre")
     SelectedPrefix =  "*S-"
  Else 
     SelectedPrefix =  ""
  End if
  GenreList = GenreList & vbLF & SelectedPrefix & r(Row)("genre") & vbTAB & r(Row)("genre")
 'MusicList = Row & vbCR
Next

Set r = Nothing

SetPropertyValue "Jukebox" & ZoneString & ".Genre List", GenreList

End Function


Sub PopulatePlayList(selectedtag)
' If selectedtag = 0 process as normal

   Dim PlayList, SqlStr, r, PageNmbr
   PlayList = ""
   
   SqlStr = "select songs.title, songqueue.songid from songs inner join songqueue on songs.id = songqueue.songid where songqueue.playlistid = " & Zone
   Set r = objDB.Execute(SqlStr)
   
   ' Get page number
   PageNmbr = CInt(GetPropertyValue("Jukebox" & ZoneString & ".Jukebox Song Queue List Page Count"))
   sleep 50

  ' Page Logic 
   TotalPages = ((r.Count-1)\100)+1
   
   SetPropertyValue "Jukebox" & ZoneString & ".Jukebox Song Queue List Page Total", TotalPages
   
   ' Check Subscript Range
   If PageNmbr  >  TotalPages Then
      PageNmbr = TotalPages
   End If
   'MsgBox PageNmbr & ", " &  TotalPages & "," & r.Count  
   
   SetPropertyValue "Jukebox" & ZoneString & ".Jukebox Song Queue List Page Count", PageNmbr
   LastPage =  r.Count Mod 100
   If LastPage = 0  Then
      LastPage = 100
   End if
   If PageNmbr <= 1 Then
         StartCount = 1
   Else 
      MusicList = ""
      StartCount = ((PageNmbr-1)*100) + 1
   End If

   If (PageNmbr >=  TotalPages) Then
      EndCount = ((TotalPages-1)*100) + LastPage
   Else
      EndCount = PageNmbr * 100 
   End If
   ' End Of Page Logic

   'MsgBox StartCount & ", " & EndCount & "," & PageNmbr
   If r.Count = 0 Then
      PlayList     = " " & vbTAB & "Playlist Empty" & vbLF
   Else
      For Row = StartCount To EndCount
         If CInt(selectedtag) = Row Then
            'MsgBox selectedtag & ", " & Row
            PlayList = PlayList & "*S-" & "PlayList^" & Row & "^" & r(Row)("songid") & vbTAB & r(Row)("title") &vbLF
         Else
            PlayList = PlayList & "PlayList^" & Row & "^" & r(Row)("songid") & vbTAB & r(Row)("title") &vbLF
         End if
         'MusicList = Row & vbCR
      Next
   End If
   SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Playlist", Left(PlayList,Len(PlayList)-1) 
   'msgbox "Setting Playlist for zone " & ZoneString
   Set r = Nothing
End Sub


Function PlayListSongID(PlayListID)
   Dim Playlist, StrPos, RightStr, data
   PlayList = GetPropertyValue("Jukebox" & ZoneString & ".Jukebox - Playlist")
   ' MsgBox "PlayList^" & PlayListID & "^"
   LeftStrPos = InStr(PlayList,"PlayList^" & PlayListID & "^")
   RightStr = Mid(PlayList,LeftStrPos)
   RightStrPos = InStr(RightStr,vbTAB)
   PlaylistRecordStr = Left(RightStr,RightStrPos-1)
   data = Split(PlaylistRecordStr,"^") 
   PlayListSongID=data(2)
End Function



Function ClearPlaylist
   SqlStr = "delete from songqueue where songqueue.playlistid = " & Zone
   objDB.Execute su.Sprintf(SqlStr)
   SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Playlist Modified","Yes"
   sleep 150
   Call PopulatePlayList(0)
End Function

Sub ShufflePlaylist
   SqlStr = "select playlistid, songid from songqueue where songqueue.playlistid = " & Zone & " order by random()"
   Set r = objDB.Execute(SqlStr)
   SqlStr = "delete from songqueue where songqueue.playlistid = " & Zone
   Set ra = objDB.Execute(SqlStr)
   For Row = 1 To r.Count
       objDB.Execute su.Sprintf("INSERT INTO songqueue (playlistid, songid) VALUES (%Nq,%Nq)",Zone,r(Row)("songid"))
   Next
   SetPropertyValue "Jukebox" & ZoneString & ".Jukebox - Playlist Modified","Yes"
   Set r = Nothing
   sleep 150
   Call PopulatePlayList(0)
End Sub

Sub ImportMusicLibrary

Dim objFSO , objTextFile, oShell, r, s 
Dim CmdStr, RetCode, strNextLine, TitleStr, ArtistStr, AlbumStr, TrackStr, GenreStr, YearStr, FileStr, SqlStr, song_id, str_pos, data, CountStr

SetpropertyValue "Jukebox" & ZoneString & ".Jukebox - Import Flag", "Running"

CmdStr = """" & DOSHousebotLocation & "config\scripts\songs.cmd""" 

'CmdStr = "c:\Progra~1\housebot\config\scripts\id3 -2 -q ""Title  :" & Chr(37) & "t\nArtist : %%a\nAlbum  : %%l\nTrack  : %%n\nGenre  : %%g\nYear   : %%y\nFile   : %%p%%f\nCount  : %%X\n"" -R ""e:\music\*.mp3"""

 '-- Execute the command and redirect the output to the file
SetpropertyValue "Jukebox" & ZoneString & ".Jukebox - Import Messages", "Building Tag List - Please Wait"

Set oShell = CreateObject( "WScript.Shell" )
oShell.Run CmdStr, 0, True
sleep 100
Set objFSO = CreateObject("Scripting.FileSystemObject")
Set objTextFile = objFSO.OpenTextFile(HousebotLocation & "config\scripts\songs.tmp", 1)

'SetPropertyValue "Import Music Library.Execute Program", "Yes"

'Clear Tables
' objDB.Execute su.Sprintf("DELETE FROM SONGS")
objDB.Execute su.Sprintf("DELETE FROM GENRE")
Do Until objTextFile.AtEndOfStream
    strNextLine = objTextFile.Readline
    ' Process song record 
	If Left(strNextLine,9) = "Title  : " Then
       TitleStr =  Mid(strNextLine,10, len(strNextLine) - 9)
       strNextLine = objTextFile.Readline
       ArtistStr =  Mid(strNextLine,10, len(strNextLine) - 9)
	   strNextLine = objTextFile.Readline
       AlbumStr =  Mid(strNextLine,10, len(strNextLine) - 9)
	   strNextLine = objTextFile.Readline
       TrackStr =  Mid(strNextLine,10, len(strNextLine) - 9)
	   strNextLine = objTextFile.Readline
       GenreStr =  Mid(strNextLine,10, len(strNextLine) - 9)
       strNextLine = objTextFile.Readline
       YearStr =  Mid(strNextLine,10, len(strNextLine) - 9)
       strNextLine = objTextFile.Readline
       FileStr =  Mid(strNextLine,10, len(strNextLine) - 9)
	   strNextLine = objTextFile.Readline
       CountStr =  Mid(strNextLine,10, len(strNextLine) - 9)
	   sleep 5
       SetpropertyValue "Jukebox" & ZoneString & ".Jukebox - Import Messages", "Adding song: " & TitleStr
	   SetpropertyValue "Jukebox" & ZoneString & ".Jukebox - Library Song Count", CountStr
       
	   'this checks for a bug in id3.exe 
	   If Left(GenreStr,1)  = "(" Then
	      str_pos = InStr(GenreStr, ")")
          If str_pos <> 0 Then
             data = Split(GenreStr,")")
			 GenreStr = data(1)
          End if
	   End If
       

	   'SqlStr = "Select file from songs where file = '" & FileStr & "'"

	   SqlStr = su.Sprintf("Select id, file from songs where file = %Nq",FileStr)
       Set r = objDB.Execute(SqlStr)
	   ' Only insert if new song is found  -- Otherwise, Relationships will be compromised
       If r.count < 1 Then
	      objDB.Execute su.Sprintf("INSERT INTO songs (title,artist,album,track,genre,year,file) VALUES (%Nq,%Nq,%Nq,%Nq,%Nq,%Nq,%Nq)",_
		  TitleStr,ArtistStr,AlbumStr,TrackStr,GenreStr,YearStr,FileStr)
	   Else
	      For Row = 1 To r.count
		    song_id = r(row)("id")
   			objDB.Execute su.Sprintf("Update songs set title = %Nq ,artist = %Nq, album = %Nq, track = %Nq, genre = %Nq, year = %Nq, file = %Nq where id = %Nq"_
			,TitleStr,ArtistStr,AlbumStr,TrackStr,GenreStr,YearStr,FileStr,song_id)
		  Next
	   End If
	   Set r = Nothing
	End if
Loop


SetpropertyValue "Jukebox" & ZoneString & ".Jukebox - Import Messages", "Cleaning up Orphaned Songs"
'Clean Up  - Delete all entries where a file is not found
Set objFile = CreateObject("Scripting.FileSystemObject")

Set r = objDB.Execute("select * from songs")
For Row = 1 To r.Count
   If objFile.FileExists(r(row)("file")) = False Then
      objDB.Execute("delete from songs where id = " & r(row)("id"))
   End If
Next 
Set r = Nothing


SetpropertyValue "Jukebox" & ZoneString & ".Jukebox - Import Messages", "Cleaning up Orphaned Saved Playlist"
'Clean Up  - Delete Orphaned saved playlists 
Set r = objDB.Execute("select songid from savedplaylists")
For Row = 1 To r.Count
   SetpropertyValue "Jukebox Script.Error", r(Row)("songid")    
   Set s = objDB.Execute("select id from songs where id = " & r(Row)("songid"))
   If s.Count = 0 Then
      objDB.Execute("delete from savedplaylists where songid = " & r(Row)("songid"))
   End If
Next 
Set r = Nothing
Set s = Nothing

objDB.Execute su.Sprintf("insert into genre (genre) select distinct genre from songs")

Set oShell = Nothing
objTextFile.Close
Set objFile = Nothing

SetpropertyValue "Jukebox" & ZoneString & ".Jukebox - Import Messages", "Populating Genre List"
PopulateGenreList
sleep 500
SetpropertyValue "Jukebox" & ZoneString & ".Jukebox - Import Messages", "Populating Name List"
Call PopulateNameList(1, "False")
sleep 500
Call PopulatePlayList (0)
SetpropertyValue "Jukebox" & ZoneString & ".Jukebox - Import Messages", "Populating Play List"

'Read in file of Internet Radio stations
Set objTextFile = objFSO.OpenTextFile(HousebotLocation & "config\scripts\InternetRadio.txt", 1)
Do Until objTextFile.AtEndOfStream
    strNextLine = objTextFile.Readline
    ' Process station record 
	If Left(strNextLine,9) = "Title  : " Then
       TitleStr =  Mid(strNextLine,10, len(strNextLine) - 9)
       strNextLine = objTextFile.Readline
       FileStr =  Mid(strNextLine,10, len(strNextLine) - 9)
	   strNextLine = objTextFile.Readline
       CountStr =  Mid(strNextLine,10, len(strNextLine) - 9)
	   sleep 5
	   
	   SqlStr = su.Sprintf("Select id, path from internetstream where path = %Nq",FileStr)
       Set r = objDB.Execute(SqlStr)
	   ' Only insert if new station is found  
       If r.count < 1 Then
	      objDB.Execute su.Sprintf("INSERT INTO internetstream (title,path) VALUES (%Nq,%Nq)", TitleStr,FileStr)
	   End If
	   Set r = Nothing
	End if
Loop

Set objTextFile = Nothing
Set objFSO = Nothing

SetpropertyValue "Jukebox" & ZoneString & ".Jukebox - Import Flag", "Stopped"
SetpropertyValue "Jukebox" & ZoneString & ".Jukebox - Import Messages", ""
End Sub
